//+------------------------------------------------------------------+
//|                       double dynamic zone williams percent range |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  Gold
#property indicator_width1  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style6  STYLE_DASH


//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuy(double& sourceArray[],double initValue, int lookBack, int bars, int i );
   double dzSell(double& sourceArray[],double initValue, int lookBack, int bars, int i );
#import

//
//
//
//
//

extern int    Smooth                  =  3;
extern int    SmoothMode              = MODE_LWMA;
extern int    DzLookBackBars          = 70;
extern double DzStartBuyProbability1  = 0.15;
extern double DzStartSellProbability1 = 0.15;
extern double DzStartBuyProbability2  = 0.02;
extern double DzStartSellProbability2 = 0.02;


//
//
//
//
//

double rbcis[];
double rbci[];
double bli1[];
double sli1[];
double bli2[];
double sli2[];
double slic[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,rbci);
   SetIndexBuffer(1,bli1);
   SetIndexBuffer(2,sli1);
   SetIndexBuffer(3,bli2);
   SetIndexBuffer(4,sli2);
   SetIndexBuffer(5,slic);
   SetIndexBuffer(6,rbcis);
   

   //
   //
   //
   //
   //
   
   IndicatorShortName ("DDZ RBCI ("+Smooth+","+DzLookBackBars+","+DoubleToStr(DzStartBuyProbability1,3)+","+DoubleToStr(DzStartSellProbability1,3)+","+DoubleToStr(DzStartBuyProbability2,3)+","+DoubleToStr(DzStartSellProbability2,3)+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

   for(i=limit; i >= 0; i--) rbci[i] = iCustom(NULL,0,"RBCI",0,i);
   for(i=limit; i >= 0; i--)
   { 
      
      rbcis[i] = iMAOnArray(rbci,0,Smooth,0,SmoothMode,i);
      bli1[i]  = dzBuy (rbcis, DzStartBuyProbability1,  DzLookBackBars, Bars, i);
      sli1[i]  = dzSell(rbcis, DzStartSellProbability1, DzLookBackBars, Bars, i);
      bli2[i]  = dzBuy (rbcis, DzStartBuyProbability2,  DzLookBackBars, Bars, i);
      sli2[i]  = dzSell(rbcis, DzStartSellProbability2, DzLookBackBars, Bars, i);
      slic[i]  = dzSell(rbcis, 0.5                    , DzLookBackBars, Bars, i);
    }
   //
   //
   //
   //
   //
   return(0);
}

